package net.mcreator.serverlist.client.gui;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.EditBox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.Minecraft;

import net.mcreator.serverlist.world.inventory.Page2Menu;
import net.mcreator.serverlist.network.Page2ButtonMessage;
import net.mcreator.serverlist.ServerListMod;

import java.util.HashMap;

import com.mojang.blaze3d.vertex.PoseStack;
import com.mojang.blaze3d.systems.RenderSystem;

public class Page2Screen extends AbstractContainerScreen<Page2Menu> {
	private final static HashMap<String, Object> guistate = Page2Menu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	EditBox pvp_legacy;
	EditBox minemen;
	Button button_1;
	Button button_3;
	Button button_4;

	public Page2Screen(Page2Menu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 166;
	}

	private static final ResourceLocation texture = new ResourceLocation("server_list:textures/screens/page_2.png");

	@Override
	public void render(PoseStack ms, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(ms);
		super.render(ms, mouseX, mouseY, partialTicks);
		this.renderTooltip(ms, mouseX, mouseY);
		pvp_legacy.render(ms, mouseX, mouseY, partialTicks);
		minemen.render(ms, mouseX, mouseY, partialTicks);
	}

	@Override
	protected void renderBg(PoseStack ms, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		RenderSystem.setShaderTexture(0, texture);
		this.blit(ms, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		if (pvp_legacy.isFocused())
			return pvp_legacy.keyPressed(key, b, c);
		if (minemen.isFocused())
			return minemen.keyPressed(key, b, c);
		return super.keyPressed(key, b, c);
	}

	@Override
	public void containerTick() {
		super.containerTick();
		pvp_legacy.tick();
		minemen.tick();
	}

	@Override
	protected void renderLabels(PoseStack poseStack, int mouseX, int mouseY) {
		this.font.draw(poseStack, Component.translatable("gui.server_list.page_2.label_pvp"), 10, 7, -12829636);
		this.font.draw(poseStack, Component.translatable("gui.server_list.page_2.label_pvp_legacy"), 10, 25, -12829636);
		this.font.draw(poseStack, Component.translatable("gui.server_list.page_2.label_minemen"), 10, 61, -12829636);
	}

	@Override
	public void onClose() {
		super.onClose();
		Minecraft.getInstance().keyboardHandler.setSendRepeatsToGui(false);
	}

	@Override
	public void init() {
		super.init();
		this.minecraft.keyboardHandler.setSendRepeatsToGui(true);
		pvp_legacy = new EditBox(this.font, this.leftPos + 10, this.topPos + 34, 120, 20, Component.translatable("gui.server_list.page_2.pvp_legacy")) {
			{
				setSuggestion(Component.translatable("gui.server_list.page_2.pvp_legacy").getString());
			}

			@Override
			public void insertText(String text) {
				super.insertText(text);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.server_list.page_2.pvp_legacy").getString());
				else
					setSuggestion(null);
			}

			@Override
			public void moveCursorTo(int pos) {
				super.moveCursorTo(pos);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.server_list.page_2.pvp_legacy").getString());
				else
					setSuggestion(null);
			}
		};
		pvp_legacy.setMaxLength(32767);
		guistate.put("text:pvp_legacy", pvp_legacy);
		this.addWidget(this.pvp_legacy);
		minemen = new EditBox(this.font, this.leftPos + 10, this.topPos + 70, 120, 20, Component.translatable("gui.server_list.page_2.minemen")) {
			{
				setSuggestion(Component.translatable("gui.server_list.page_2.minemen").getString());
			}

			@Override
			public void insertText(String text) {
				super.insertText(text);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.server_list.page_2.minemen").getString());
				else
					setSuggestion(null);
			}

			@Override
			public void moveCursorTo(int pos) {
				super.moveCursorTo(pos);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.server_list.page_2.minemen").getString());
				else
					setSuggestion(null);
			}
		};
		minemen.setMaxLength(32767);
		guistate.put("text:minemen", minemen);
		this.addWidget(this.minemen);
		button_1 = new Button(this.leftPos + 10, this.topPos + -20, 30, 20, Component.translatable("gui.server_list.page_2.button_1"), e -> {
			if (true) {
				ServerListMod.PACKET_HANDLER.sendToServer(new Page2ButtonMessage(0, x, y, z));
				Page2ButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		});
		guistate.put("button:button_1", button_1);
		this.addRenderableWidget(button_1);
		button_3 = new Button(this.leftPos + 70, this.topPos + -20, 30, 20, Component.translatable("gui.server_list.page_2.button_3"), e -> {
			if (true) {
				ServerListMod.PACKET_HANDLER.sendToServer(new Page2ButtonMessage(1, x, y, z));
				Page2ButtonMessage.handleButtonAction(entity, 1, x, y, z);
			}
		});
		guistate.put("button:button_3", button_3);
		this.addRenderableWidget(button_3);
		button_4 = new Button(this.leftPos + 100, this.topPos + -20, 30, 20, Component.translatable("gui.server_list.page_2.button_4"), e -> {
			if (true) {
				ServerListMod.PACKET_HANDLER.sendToServer(new Page2ButtonMessage(2, x, y, z));
				Page2ButtonMessage.handleButtonAction(entity, 2, x, y, z);
			}
		});
		guistate.put("button:button_4", button_4);
		this.addRenderableWidget(button_4);
	}
}
