package net.mcreator.serverlist.client.gui;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.EditBox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.Minecraft;

import net.mcreator.serverlist.world.inventory.Page4Menu;
import net.mcreator.serverlist.network.Page4ButtonMessage;
import net.mcreator.serverlist.ServerListMod;

import java.util.HashMap;

import com.mojang.blaze3d.vertex.PoseStack;
import com.mojang.blaze3d.systems.RenderSystem;

public class Page4Screen extends AbstractContainerScreen<Page4Menu> {
	private final static HashMap<String, Object> guistate = Page4Menu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	EditBox minehut;
	Button button_1;
	Button button_2;
	Button button_3;

	public Page4Screen(Page4Menu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 166;
	}

	private static final ResourceLocation texture = new ResourceLocation("server_list:textures/screens/page_4.png");

	@Override
	public void render(PoseStack ms, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(ms);
		super.render(ms, mouseX, mouseY, partialTicks);
		this.renderTooltip(ms, mouseX, mouseY);
		minehut.render(ms, mouseX, mouseY, partialTicks);
	}

	@Override
	protected void renderBg(PoseStack ms, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		RenderSystem.setShaderTexture(0, texture);
		this.blit(ms, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		if (minehut.isFocused())
			return minehut.keyPressed(key, b, c);
		return super.keyPressed(key, b, c);
	}

	@Override
	public void containerTick() {
		super.containerTick();
		minehut.tick();
	}

	@Override
	protected void renderLabels(PoseStack poseStack, int mouseX, int mouseY) {
		this.font.draw(poseStack, Component.translatable("gui.server_list.page_4.label_other"), 10, 7, -12829636);
		this.font.draw(poseStack, Component.translatable("gui.server_list.page_4.label_minehut"), 10, 25, -12829636);
	}

	@Override
	public void onClose() {
		super.onClose();
		Minecraft.getInstance().keyboardHandler.setSendRepeatsToGui(false);
	}

	@Override
	public void init() {
		super.init();
		this.minecraft.keyboardHandler.setSendRepeatsToGui(true);
		minehut = new EditBox(this.font, this.leftPos + 10, this.topPos + 34, 120, 20, Component.translatable("gui.server_list.page_4.minehut")) {
			{
				setSuggestion(Component.translatable("gui.server_list.page_4.minehut").getString());
			}

			@Override
			public void insertText(String text) {
				super.insertText(text);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.server_list.page_4.minehut").getString());
				else
					setSuggestion(null);
			}

			@Override
			public void moveCursorTo(int pos) {
				super.moveCursorTo(pos);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.server_list.page_4.minehut").getString());
				else
					setSuggestion(null);
			}
		};
		minehut.setMaxLength(32767);
		guistate.put("text:minehut", minehut);
		this.addWidget(this.minehut);
		button_1 = new Button(this.leftPos + 10, this.topPos + -20, 30, 20, Component.translatable("gui.server_list.page_4.button_1"), e -> {
			if (true) {
				ServerListMod.PACKET_HANDLER.sendToServer(new Page4ButtonMessage(0, x, y, z));
				Page4ButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		});
		guistate.put("button:button_1", button_1);
		this.addRenderableWidget(button_1);
		button_2 = new Button(this.leftPos + 40, this.topPos + -20, 30, 20, Component.translatable("gui.server_list.page_4.button_2"), e -> {
			if (true) {
				ServerListMod.PACKET_HANDLER.sendToServer(new Page4ButtonMessage(1, x, y, z));
				Page4ButtonMessage.handleButtonAction(entity, 1, x, y, z);
			}
		});
		guistate.put("button:button_2", button_2);
		this.addRenderableWidget(button_2);
		button_3 = new Button(this.leftPos + 70, this.topPos + -20, 30, 20, Component.translatable("gui.server_list.page_4.button_3"), e -> {
			if (true) {
				ServerListMod.PACKET_HANDLER.sendToServer(new Page4ButtonMessage(2, x, y, z));
				Page4ButtonMessage.handleButtonAction(entity, 2, x, y, z);
			}
		});
		guistate.put("button:button_3", button_3);
		this.addRenderableWidget(button_3);
	}
}
